%define version 4.0.3pl1
%define so_version 4
%define release C3r5

Name: php
Summary: PHP: Hypertext Preprocessor
Group: Development/Languages
Version: %{version}
Release: %{release}
Copyright: The PHP license (see "LICENSE" file included in distribution)
Source: http://www.php.net/version4/downloads/php-%{version}.tar.gz
Patch0: php-4.0.3-config.patch
Patch1: php-4.0.3-security.patch
Patch2: php-4.0.3-imap_mail2.patch
Patch3: php-4.0.3-configure.patch
Patch4: php-4.0.4-config-script.patch
Patch5: php-4.0.3-mem-leak.patch

#Icon: php4.gif
URL: http://www.php.net/
Packager: PHP Group <group@php.net>

# this is really bad, but interbase doesn't have a versioned soname
Provides: libgds.so

BuildRoot: /var/tmp/php-%{version}

%description
PHP is an HTML-embedded scripting language. Much of its syntax is
borrowed from C, Java and Perl with a couple of unique PHP-specific
features thrown in. The goal of the language is to allow web
developers to write dynamically generated pages quickly.

%package devel
Group: Development/Libraries
Summary: development headers for php
Requires: php

%description devel
The php-devel package contains the code necessary for building dynamic
shared libraries for PHP.


%prep

%setup
%patch0 -p1 -b .config
%patch1 -p1 -b .security
%patch2 -p1 -b .imap_mail2
%patch3 -p1 -b .configure
%patch4 -p0 -b .quotes
%patch5 -p0 -b .mem-leak

%build
APXS=/usr/sbin/apxs

# we need to configure first, or we get stuff confused
#./configure --prefix=/usr --with-apxs=$APXS --enable-track-vars \
#	    --disable-debug --enable-xml
# figure out configure options options based on what packages are installed
# to override, use the OVERRIDE_OPTIONS environment variable.  To add
# extra options, use the OPTIONS environment variable.
OPTIONS="$OPTIONS --enable-safe-mode \
	 --with-config-file-path=/etc/httpd --with-exec-dir=/usr/bin \
	 --with-zlib --enable-magic-quotes --with-regex=system \
  	 --enable-track-vars \
	 --enable-xml --disable-debug"
test `rpm -q InterBaseCS_LI` && OPTIONS="$OPTIONS --with-interbase=shared"
test `rpm -q MySQL-devel` && OPTIONS="$OPTIONS --with-mysql=shared"
test `rpm -q postgresql-devel` && OPTIONS="$OPTIONS --with-pgsql=shared"
test `rpm -q openldap-devel` && OPTIONS="$OPTIONS --with-ldap"
test `rpm -q imap-devel` && OPTIONS="$OPTIONS --with-imap"

# check for pdflib support..
test `rpm -q pdflib-devel` && OPTIONS="$OPTIONS --with-pdflib=/usr"
test `rpm -q libjpeg` && OPTIONS="$OPTIONS --with-jpeg-dir=/usr"
test `rpm -q libtiff` && OPTIONS="$OPTIONS --with-tiff-dir=/usr"
test `rpm -q libpng` && OPTIONS="$OPTIONS --with-png-dir=/usr"

# fail if we don't have imap support:
test `rpm -q imap-devel`
# imap needs this:
test -e /usr/lib/libc-client.a || ln -s /usr/lib/c-client.a /usr/lib/libc-client.a

./buildconf
if test "x$OVERRIDE_OPTIONS" = "x"; then
    CFLAGS="-DEAPI $RPM_OPT_FLAGS" ./configure --prefix=/usr --with-apxs=$APXS $OPTIONS
else
    CFLAGS="$RPM_OPT_FLAGS" ./configure $OVERRIDE_OPTIONS
fi

make

%install
mkdir -p $RPM_BUILD_ROOT/usr/bin
mkdir -p $RPM_BUILD_ROOT/usr/lib/apache
mkdir -p $RPM_BUILD_ROOT/usr/lib/apache/php
mkdir -p $RPM_BUILD_ROOT/usr/include/php
mkdir -p $RPM_BUILD_ROOT/usr/include/php/Zend
mkdir -p $RPM_BUILD_ROOT/usr/include/php/ext/standard
mkdir -p $RPM_BUILD_ROOT/usr/include/php/regex
strip --strip-debug .libs/libphp4.so
install -m 755 .libs/libphp4.so $RPM_BUILD_ROOT/usr/lib/apache

# let php install the modules, it seems to get that right at least
make install-modules moduledir=$RPM_BUILD_ROOT/usr/lib/apache/php

# php header files
make -C pear install-headers includedir=$RPM_BUILD_ROOT/usr/include

# install the build tools for compiling modules after installing php
make -C pear install-build install-programs bindir=$RPM_BUILD_ROOT/usr/bin prefix=$RPM_BUILD_ROOT/usr

# don't install pear libraries because it requires the php binary which we don't
# build
make -C pear install-data-local PEAR_INSTALLDIR=$RPM_BUILD_ROOT/usr/lib/php

# install the commandline version. this is a massive hack, but the
# php build system doesn't allow you to build both the mod_php and 
# commandline version at the same time. 
make clean

# figure out configure options options based on what packages are installed
# to override, use the OVERRIDE_OPTIONS environment variable.  To add
# extra options, use the OPTIONS environment variable.
OPTIONS="$OPTIONS --enable-safe-mode \
	 --with-config-file-path=/etc/httpd --with-exec-dir=/usr/bin \
	 --with-zlib --enable-magic-quotes --with-regex=system \
  	 --enable-track-vars \
	 --enable-xml --disable-debug"
test `rpm -q InterBaseCS_LI` && OPTIONS="$OPTIONS --with-interbase=shared"
test `rpm -q MySQL-devel` && OPTIONS="$OPTIONS --with-mysql=shared"
test `rpm -q postgresql-devel` && OPTIONS="$OPTIONS --with-pgsql=shared"
test `rpm -q openldap-devel` && OPTIONS="$OPTIONS --with-ldap"
test `rpm -q imap-devel` && OPTIONS="$OPTIONS --with-imap"

# check for pdflib support..
test `rpm -q pdflib-devel` && OPTIONS="$OPTIONS --with-pdflib=/usr"
test `rpm -q libjpeg` && OPTIONS="$OPTIONS --with-jpeg-dir=/usr"
test `rpm -q libtiff` && OPTIONS="$OPTIONS --with-tiff-dir=/usr"
test `rpm -q libpng` && OPTIONS="$OPTIONS --with-png-dir=/usr"

# fail if we don't have imap support:
test `rpm -q imap-devel`
# imap needs this:
test -e /usr/lib/libc-client.a || ln -s /usr/lib/c-client.a /usr/lib/libc-client.a

if test "x$OVERRIDE_OPTIONS" = "x"; then
	CFLAGS="$CFLAGS $RPM_OPT_FLAGS" ./configure --prefix=/usr --disable-apxs $OPTIONS
else
	CFLAGS="$CFLAGS $RPM_OPT_FLAGS" ./configure $OVERRIDE_OPTIONS
fi
make
mkdir -p $RPM_BUILD_ROOT/usr/bin/
install -m 755 php $RPM_BUILD_ROOT/usr/bin/php

%files
/usr/bin/php
/usr/bin/pear
/usr/lib/apache/*
/usr/lib/php/*.php
/usr/lib/php/DB
/usr/lib/php/HTML
/usr/lib/php/Benchmark
/usr/lib/php/File
/usr/lib/php/Net
/usr/lib/php/Payment
/usr/lib/php/PEAR
/usr/lib/php/XML

%files devel
/usr/bin/php-config
/usr/bin/phpextdist
/usr/bin/phpize
/usr/include/php
/usr/lib/php/build

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Wed May 30 2001 Patrick Baltz <patrick.baltz@sun.com> %{version}-%{release}
- add patch to eliminate php memory leak when restarting apache

* Thu Apr 26 2001 Patrick Baltz <patrick.baltz@sun.com>
- re-roll php with the build tools and the php binary

* Fri Nov	17 2000 Mike Waychison <mwaychison@cobalt.com>
- Rolled the raq rpms.
- Made a patch for ./configure and fixed up some of its nonsensities

* Sat Oct 28 2000 Mike Waychison <mwaychison@cobalt.com>
- Reved up to 4.0.3pl1 for content-length fix
- Made imap_mail2 one patch
- Added the TSRM headers for modularity

* Thu Aug 31 2000 Mike Waychison <mwaychison@cobalt.com>
- Reved PHP up to 4.0.2
- Added a diff from the PHP CVS that should fix XML parse problems
